3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 exclude= pass it through git-apply
26 C= pass it through git-apply
27 p= pass it through git-apply
28 patch-format= format the patch(es) are in
29 reject pass it through git-apply
30 resolvemsg= override error message when patch failure occurs
31 continue continue applying patches after resolving a conflict
32 r,resolved synonyms for --continue
33 skip skip the current patch
34 abort restore the original branch and abort the patching operation.
35 committer-date-is-author-date lie about committer date
36 ignore-date use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing* (internal use for git-rebase)"
42 prefix=$(git rev-parse --show-prefix)
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48 die "$(gettext "You need to set your committer info first")"
50 if git rev-parse --verify -q HEAD >/dev/null
58 if test '' != "$interactive"
62 if test '' != "$threeway"
68 git rev-parse --sq-quote "$@"
72 echo "$1" >"$dotest/next"
73 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
78 if test -f "$dotest/dirtyindex"
83 if ! test -s "$dotest/abort-safety"
88 abort_safety=$(cat "$dotest/abort-safety")
89 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
94 gettext "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" &&
101 stop_here_user_resolve () {
102 if [ -n "$resolvemsg" ]; then
103 printf '%s\n' "$resolvemsg"
106 eval_gettext "When you have resolved this problem run \"\$cmdline --resolved\".
107 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
108 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
114 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
115 "$dotest/patch" "$dotest/info"
116 echo "$next" >"$dotest/next"
122 gettext "Cannot fall back to three-way merge."; echo
127 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
129 rm -fr "$dotest"/patch-merge-*
130 mkdir "$dotest/patch-merge-tmp-dir"
132 # First see if the patch records the index info that we can use.
133 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say Using index info to reconstruct a base tree...
140 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
141 git apply --cached <"$dotest/patch"
143 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
144 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
146 cannot_fallback "$(gettext "Did you hand edit your patch?
147 It does not apply to blobs recorded in its index.")"
150 test -f "$dotest/patch-merge-index" &&
151 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
152 orig_tree=$(cat "$dotest/patch-merge-base") &&
153 rm -fr "$dotest"/patch-merge-* || exit 1
155 say "$(gettext "Falling back to patching base and 3-way merge...")"
157 # This is not so wrong. Depending on which base we picked,
158 # orig_tree may be wildly different from ours, but his_tree
159 # has the same set of wildly different changes in parts the
160 # patch did not touch, so recursive ends up canceling them,
161 # saying that we reverted all those changes.
163 eval GITHEAD_$his_tree='"$FIRSTLINE"'
164 export GITHEAD_$his_tree
165 if test -n "$GIT_QUIET"
167 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
169 git-merge-recursive $orig_tree -- HEAD $his_tree || {
170 git rerere $allow_rerere_autoupdate
171 echo Failed to merge in the changes.
174 unset GITHEAD_$his_tree
178 test $# = 0 || echo >&2 "$@"
185 check_patch_format () {
186 # early return if patch_format was set from the command line
187 if test -n "$patch_format"
192 # we default to mbox format if input is from stdin and for
194 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
200 # otherwise, check the first few lines of the first patch to try
201 # to detect its format
207 "From "* | "From: "*)
210 '# This series applies on GIT commit'*)
211 patch_format=stgit-series
213 "# HG changeset patch")
217 # if the second line is empty and the third is
218 # a From, Author or Date entry, this is very
219 # likely an StGIT patch
221 ,"From: "* | ,"Author: "* | ,"Date: "*)
229 if test -z "$patch_format" &&
234 # This begins with three non-empty lines. Is this a
235 # piece of e-mail a-la RFC2822? Grab all the headers,
236 # discarding the indented remainder of folded lines,
237 # and see if it looks like that they all begin with the
238 # header field names...
240 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
241 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
244 } < "$1" || clean_abort
248 case "$patch_format" in
250 if test -n "$rebasing" || test t = "$keepcr"
256 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
262 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
264 series_dir=`dirname "$1"`
271 set "$@" "$series_dir/$filename"
273 # remove the safety x
275 # remove the arg coming from the first-line comment
277 } < "$series_file" || clean_abort
278 # set the patch format appropriately
280 # now handle the actual StGIT patches
287 this=`expr "$this" + 1`
288 msgnum=`printf "%0${prec}d" $this`
289 # Perl version of StGIT parse_patch. The first nonemptyline
290 # not starting with Author, From or Date is the
291 # subject, and the body starts with the next nonempty
292 # line not starting with Author, From or Date
293 perl -ne 'BEGIN { $subject = 0 }
294 if ($subject > 1) { print ; }
295 elsif (/^\s+$/) { next ; }
296 elsif (/^Author:/) { print s/Author/From/ ; }
297 elsif (/^(From|Date)/) { print ; }
303 print "Subject: ", $_ ;
306 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
308 echo "$this" > "$dotest/last"
313 if test -n "$parse_patch" ; then
314 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
316 clean_abort "$(gettext "Patch format detection failed.")"
323 dotest="$GIT_DIR/rebase-apply"
324 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
325 resolvemsg= resume= scissors= no_inbody_headers=
327 committer_date_is_author_date=
329 allow_rerere_autoupdate=
331 if test "$(git config --bool --get am.keepcr)" = true
348 utf8=t ;; # this is now default
357 -r|--resolved|--continue)
364 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
366 die "$(gettext "-d option is no longer supported. Do not use.")"
369 shift; resolvemsg=$1 ;;
370 --whitespace|--directory|--exclude)
371 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
373 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
375 shift ; patch_format="$1" ;;
376 --reject|--ignore-whitespace|--ignore-space-change)
377 git_apply_opt="$git_apply_opt $1" ;;
378 --committer-date-is-author-date)
379 committer_date_is_author_date=t ;;
382 --rerere-autoupdate|--no-rerere-autoupdate)
383 allow_rerere_autoupdate="$1" ;;
398 # If the dotest directory exists, but we have finished applying all the
399 # patches in them, clear it out.
400 if test -d "$dotest" &&
401 last=$(cat "$dotest/last") &&
402 next=$(cat "$dotest/next") &&
404 test "$next" -gt "$last"
411 case "$#,$skip$resolved$abort" in
413 # Explicit resume command and we do not have file, so
417 # No file input but without resume parameters; catch
418 # user error to feed us a patch from standard input
419 # when there is already $dotest. This is somewhat
420 # unreliable -- stdin could be /dev/null for example
421 # and the caller did not intend to feed us a patch but
422 # wanted to continue unattended.
429 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
432 case "$skip,$abort" in
434 die "$(gettext "Please make up your mind. --skip or --abort?")"
438 git read-tree --reset -u HEAD HEAD
439 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
441 git update-ref ORIG_HEAD $orig_head
444 if test -f "$dotest/rebasing"
446 exec git rebase --abort
451 git read-tree --reset -u HEAD ORIG_HEAD
457 rm -f "$dotest/dirtyindex"
459 # Make sure we are not given --skip, --resolved, nor --abort
460 test "$skip$resolved$abort" = "" ||
461 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
464 mkdir -p "$dotest" || exit
466 if test -n "$prefix" && test $# != 0
471 test -n "$first" && {
475 if is_absolute_path "$arg"
479 set "$@" "$prefix$arg"
485 check_patch_format "$@"
489 # -i can and must be given when resuming; everything
491 echo " $git_apply_opt" >"$dotest/apply-opt"
492 echo "$threeway" >"$dotest/threeway"
493 echo "$sign" >"$dotest/sign"
494 echo "$utf8" >"$dotest/utf8"
495 echo "$keep" >"$dotest/keep"
496 echo "$keepcr" >"$dotest/keepcr"
497 echo "$scissors" >"$dotest/scissors"
498 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
499 echo "$GIT_QUIET" >"$dotest/quiet"
500 echo 1 >"$dotest/next"
501 if test -n "$rebasing"
503 : >"$dotest/rebasing"
505 : >"$dotest/applying"
506 if test -n "$HAS_HEAD"
508 git update-ref ORIG_HEAD HEAD
510 git update-ref -d ORIG_HEAD >/dev/null 2>&1
515 git update-index -q --refresh
521 files=$(git ls-files) ;;
523 files=$(git diff-index --cached --name-only HEAD --) ;;
527 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
528 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
532 if test "$(cat "$dotest/utf8")" = t
538 if test "$(cat "$dotest/keep")" = t
542 case "$(cat "$dotest/keepcr")" in
546 keepcr=--no-keep-cr ;;
548 case "$(cat "$dotest/scissors")" in
550 scissors=--scissors ;;
552 scissors=--no-scissors ;;
554 if test "$(cat "$dotest/no_inbody_headers")" = t
556 no_inbody_headers=--no-inbody-headers
560 if test "$(cat "$dotest/quiet")" = t
564 if test "$(cat "$dotest/threeway")" = t
568 git_apply_opt=$(cat "$dotest/apply-opt")
569 if test "$(cat "$dotest/sign")" = t
571 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
573 s/^/Signed-off-by: /'
579 last=`cat "$dotest/last"`
580 this=`cat "$dotest/next"`
583 this=`expr "$this" + 1`
587 while test "$this" -le "$last"
589 msgnum=`printf "%0${prec}d" $this`
590 next=`expr "$this" + 1`
591 test -f "$dotest/$msgnum" || {
597 # If we are not resuming, parse and extract the patch information
598 # into separate files:
599 # - info records the authorship and title
600 # - msg is the rest of commit log message
601 # - patch is the patch body.
603 # When we are resuming, these files are either already prepared
604 # by the user, or the user can tell us to do so by --resolved flag.
607 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
608 <"$dotest/$msgnum" >"$dotest/info" ||
611 # skip pine's internal folder data
612 sane_grep '^Author: Mail System Internal Data$' \
613 <"$dotest"/info >/dev/null &&
616 test -s "$dotest/patch" || {
617 eval_gettext "Patch is empty. Was it split wrong?
618 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
619 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
622 rm -f "$dotest/original-commit" "$dotest/author-script"
623 if test -f "$dotest/rebasing" &&
624 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
625 -e q "$dotest/$msgnum") &&
626 test "$(git cat-file -t "$commit")" = commit
628 git cat-file commit "$commit" |
629 sed -e '1,/^$/d' >"$dotest/msg-clean"
630 echo "$commit" > "$dotest/original-commit"
631 get_author_ident_from_commit "$commit" > "$dotest/author-script"
634 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
638 git stripspace > "$dotest/msg-clean"
643 if test -f "$dotest/author-script"
645 eval $(cat "$dotest/author-script")
647 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
648 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
649 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
652 if test -z "$GIT_AUTHOR_EMAIL"
654 gettext "Patch does not have a valid e-mail address."; echo
658 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
662 if test '' != "$SIGNOFF"
665 sed -ne '/^Signed-off-by: /p' \
666 "$dotest/msg-clean" |
670 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
671 test '' = "$LAST_SIGNED_OFF_BY" && echo
678 if test -s "$dotest/msg-clean"
680 cat "$dotest/msg-clean"
682 if test '' != "$ADD_SIGNOFF"
686 } >"$dotest/final-commit"
689 case "$resolved$interactive" in
691 # This is used only for interactive view option.
692 git diff-index -p --cached HEAD -- >"$dotest/patch"
698 if test "$interactive" = t
701 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
703 while test "$action" = again
705 gettext "Commit Body is:"; echo
706 echo "--------------------------"
707 cat "$dotest/final-commit"
708 echo "--------------------------"
709 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
710 # in your translation. The program will only accept English
711 # input at this point.
712 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
716 [aA]*) action=yes interactive= ;;
717 [nN]*) action=skip ;;
718 [eE]*) git_editor "$dotest/final-commit"
721 git_pager "$dotest/patch" ;;
729 if test -f "$dotest/final-commit"
731 FIRSTLINE=$(sed 1q "$dotest/final-commit")
736 if test $action = skip
742 if test -x "$GIT_DIR"/hooks/applypatch-msg
744 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
748 say "$(eval_gettext "Applying: \$FIRSTLINE")"
752 # When we are allowed to fall back to 3-way later, don't give
753 # false errors during the initial attempt.
755 if test "$threeway" = t
757 squelch='>/dev/null 2>&1 '
759 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
763 # Resolved means the user did all the hard work, and
764 # we do not have to do any patch application. Just
765 # trust what the user has in the index file and the
768 git diff-index --quiet --cached HEAD -- && {
769 gettext "No changes - did you forget to use 'git add'?
770 If there is nothing left to stage, chances are that something else
771 already introduced the same changes; you might want to skip this patch."; echo
772 stop_here_user_resolve $this
774 unmerged=$(git ls-files -u)
775 if test -n "$unmerged"
777 gettext "You still have unmerged paths in your index
778 did you forget to use 'git add'?"; echo
779 stop_here_user_resolve $this
786 if test $apply_status != 0 && test "$threeway" = t
790 # Applying the patch to an earlier tree and merging the
791 # result may have produced the same tree as ours.
792 git diff-index --quiet --cached HEAD -- && {
793 say "$(gettext "No changes -- Patch already applied.")"
797 # clear apply_status -- we have successfully merged.
801 if test $apply_status != 0
803 eval_gettext 'Patch failed at $msgnum $FIRSTLINE'; echo
804 stop_here_user_resolve $this
807 if test -x "$GIT_DIR"/hooks/pre-applypatch
809 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
812 tree=$(git write-tree) &&
814 if test -n "$ignore_date"
818 parent=$(git rev-parse --verify -q HEAD) ||
819 say >&2 "$(gettext "applying to an empty history")"
821 if test -n "$committer_date_is_author_date"
823 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
824 export GIT_COMMITTER_DATE
826 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
828 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
831 if test -f "$dotest/original-commit"; then
832 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
835 if test -x "$GIT_DIR"/hooks/post-applypatch
837 "$GIT_DIR"/hooks/post-applypatch
843 if test -s "$dotest"/rewritten; then
844 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
845 if test -x "$GIT_DIR"/hooks/post-rewrite; then
846 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten